

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Demonstration of SHyFT API implementation of Kalman Filtering on time series &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
      <li>Demonstration of SHyFT API implementation of Kalman Filtering on time series</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/grid-pp/gridpp_simple.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Demonstration-of-SHyFT-API-implementation-of-Kalman-Filtering-on-time-series">
<h1>Demonstration of SHyFT API implementation of Kalman Filtering on time series<a class="headerlink" href="#Demonstration-of-SHyFT-API-implementation-of-Kalman-Filtering-on-time-series" title="Permalink to this headline">¶</a></h1>
<div class="section" id="This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:">
<h2>This notebook gives an example of Met.no data post-processing to correct temperature forecasts based on comparison to observations. The following steps are described:<a class="headerlink" href="#This-notebook-gives-an-example-of-Met.no-data-post-processing-to-correct-temperature-forecasts-based-on-comparison-to-observations.-The-following-steps-are-described:" title="Permalink to this headline">¶</a></h2>
<ol class="arabic simple">
<li><p><strong>Loading required python modules and setting path to SHyFT installation</strong></p></li>
<li><p><strong>Generate synthetic data for temperature observations and forecasts time-series</strong></p></li>
<li><p><strong>Calculate the bias time-series using Kalman filter</strong></p></li>
<li><p><strong>Apply bias to forecasts</strong></p></li>
<li><p><strong>Plot the results</strong></p></li>
</ol>
</div>
<div class="section" id="1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">
<h2>1. Loading required python modules and setting path to SHyFT installation<a class="headerlink" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># first you should import the third-party python modules which you&#39;ll use later on</span>
<span class="c1"># the first line enables that figures are shown inline, directly in the notebook</span>
<span class="o">%</span><span class="k">pylab</span> inline
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">path</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Populating the interactive namespace from numpy and matplotlib
</pre></div></div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># once the shyft_path is set correctly, you should be able to import shyft modules</span>

<span class="kn">from</span> <span class="nn">shyft.api</span> <span class="kn">import</span> <span class="n">shyftdata_dir</span>

<span class="c1"># if you have problems here, it may be related to having your LD_LIBRARY_PATH</span>
<span class="c1"># pointing to the appropriate libboost_python libraries (.so files)</span>
<span class="kn">from</span> <span class="nn">shyft.repository.default_state_repository</span> <span class="kn">import</span> <span class="n">DefaultStateRepository</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.configuration</span> <span class="kn">import</span> <span class="n">yaml_configs</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.simulators.config_simulator</span> <span class="kn">import</span> <span class="n">ConfigSimulator</span>
<span class="kn">from</span> <span class="nn">shyft</span> <span class="kn">import</span> <span class="n">api</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># now you can access the api of shyft with tab completion and help, try this:</span>

<span class="c1">#help(api.GeoPoint) # remove the hashtag and run the cell to print the documentation of the api.GeoPoint class</span>
<span class="c1">#api. # remove the hashtag, set the pointer behind the dot and use</span>
      <span class="c1"># tab completion to see the available attributes of the shyft api</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="2.-Generate-synthetic-data-for-temperature-observations-and-forecasts-time-series">
<h2>2. Generate synthetic data for temperature observations and forecasts time-series<a class="headerlink" href="#2.-Generate-synthetic-data-for-temperature-observations-and-forecasts-time-series" title="Permalink to this headline">¶</a></h2>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create a time-axis</span>
<span class="n">t0</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">Calendar</span><span class="p">()</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2016</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<span class="n">ta</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">1</span><span class="p">),</span> <span class="mi">240</span><span class="p">)</span>

<span class="c1"># Create a TemperatureSourceVector to hold the set of observation time-series</span>
<span class="n">obs_set</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TemperatureSourceVector</span><span class="p">()</span>

<span class="c1"># Create a time-series having a constant temperature of 15 at a GeoPoint(100, 100, 100)</span>
<span class="n">ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta</span><span class="p">,</span> <span class="n">fill_value</span><span class="o">=</span><span class="mf">15.0</span><span class="p">,</span><span class="n">point_fx</span><span class="o">=</span><span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>
<span class="n">geo_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">GeoPoint</span><span class="p">(</span><span class="mi">100</span><span class="p">,</span> <span class="mi">100</span><span class="p">,</span> <span class="mi">100</span><span class="p">),</span> <span class="n">ts</span><span class="p">)</span>
<span class="n">obs_set</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">geo_ts</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create a TemperatureSourceVector to hold the set of forecast time-series</span>
<span class="n">fc_set</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TemperatureSourceVector</span><span class="p">()</span>

<span class="c1"># Create a time-series having constant offset of 2 and add it to the set of observation time-series</span>
<span class="n">off_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeSeries</span><span class="p">(</span><span class="n">ta</span><span class="p">,</span> <span class="n">fill_value</span><span class="o">=</span><span class="mf">2.0</span><span class="p">,</span><span class="n">point_fx</span><span class="o">=</span><span class="n">api</span><span class="o">.</span><span class="n">POINT_AVERAGE_VALUE</span><span class="p">)</span>
<span class="k">for</span> <span class="n">obs</span> <span class="ow">in</span> <span class="n">obs_set</span><span class="p">:</span>
    <span class="n">fc_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">obs</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span> <span class="n">obs</span><span class="o">.</span><span class="n">ts</span> <span class="o">+</span> <span class="n">off_ts</span><span class="p">)</span>
    <span class="n">fc_set</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">fc_ts</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="3.-Calculate-the-bias-time-series-using-Kalman-filter">
<h2>3. Calculate the bias time-series using Kalman filter<a class="headerlink" href="#3.-Calculate-the-bias-time-series-using-Kalman-filter" title="Permalink to this headline">¶</a></h2>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Create a TemperatureSourceVector to hold the set of bias time-series</span>
<span class="n">bias_set</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TemperatureSourceVector</span><span class="p">()</span>

<span class="c1"># Create the Kalman filter having 8 samples spaced every 3 hours to represent a daily periodic pattern</span>
<span class="n">kf</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">KalmanFilter</span><span class="p">()</span>
<span class="n">kbp</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">KalmanBiasPredictor</span><span class="p">(</span><span class="n">kf</span><span class="p">)</span>
<span class="n">kta</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">3</span><span class="p">),</span> <span class="mi">8</span><span class="p">)</span>

<span class="c1"># Calculate the coefficients of Kalman filter and</span>
<span class="c1"># Create bias time-series based on the daily periodic pattern</span>
<span class="k">for</span> <span class="n">obs</span> <span class="ow">in</span> <span class="n">obs_set</span><span class="p">:</span>
    <span class="n">kbp</span><span class="o">.</span><span class="n">update_with_forecast</span><span class="p">(</span><span class="n">fc_set</span><span class="p">,</span> <span class="n">obs</span><span class="o">.</span><span class="n">ts</span><span class="p">,</span> <span class="n">kta</span><span class="p">)</span>
    <span class="n">pattern</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">KalmanState</span><span class="o">.</span><span class="n">get_x</span><span class="p">(</span><span class="n">kbp</span><span class="o">.</span><span class="n">state</span><span class="p">)</span> <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="o">-</span><span class="mf">1.0</span><span class="p">)</span> <span class="c1"># By convention, inverse sign of pattern values</span>
    <span class="n">bias_ts</span> <span class="o">=</span> <span class="n">api</span><span class="o">.</span><span class="n">create_periodic_pattern_ts</span><span class="p">(</span><span class="n">pattern</span><span class="p">,</span> <span class="n">api</span><span class="o">.</span><span class="n">deltahours</span><span class="p">(</span><span class="mi">3</span><span class="p">),</span> <span class="n">ta</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">0</span><span class="p">),</span> <span class="n">ta</span><span class="p">)</span>
    <span class="n">bias_set</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">api</span><span class="o">.</span><span class="n">TemperatureSource</span><span class="p">(</span><span class="n">obs</span><span class="o">.</span><span class="n">mid_point</span><span class="p">(),</span> <span class="n">bias_ts</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="4.-Apply-bias-to-forecasts">
<h2>4. Apply bias to forecasts<a class="headerlink" href="#4.-Apply-bias-to-forecasts" title="Permalink to this headline">¶</a></h2>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Correct the set of forecasts by applying the set of bias time-series</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">fc_set</span><span class="p">)):</span>
    <span class="n">fc_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span> <span class="o">+=</span> <span class="n">bias_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span> <span class="c1"># By convention, add bias time-series</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Check the last value of the time-series. It should be around 15</span>
<span class="nb">print</span><span class="p">(</span><span class="n">fc_set</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">value</span><span class="p">(</span><span class="mi">239</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
15.836980529266755
</pre></div></div>
</div>
</div>
<div class="section" id="5.-Plot-the-results">
<h2>5. Plot the results<a class="headerlink" href="#5.-Plot-the-results" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">20</span><span class="p">,</span><span class="mi">15</span><span class="p">))</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">bias_set</span><span class="p">)):</span>
    <span class="n">obs</span> <span class="o">=</span> <span class="n">obs_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
    <span class="n">fc</span> <span class="o">=</span> <span class="n">fc_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
    <span class="n">bias</span> <span class="o">=</span> <span class="n">bias_set</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
    <span class="n">timestamps</span> <span class="o">=</span> <span class="p">[</span><span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">start</span><span class="p">)</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">obs</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">time_axis</span><span class="p">]</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">obs</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s1">&#39;Observation&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">fc</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s1">&#39;Forecast&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">timestamps</span><span class="p">,</span> <span class="n">bias</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s1">&#39;Bias&#39;</span><span class="p">)</span>
<span class="n">fig</span><span class="o">.</span><span class="n">autofmt_xdate</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">title</span><span class="o">=</span><span class="s1">&#39;Temperature&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s1">&#39;Temp ($^\circ$C)&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;Temp ($^\\circ$C)&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_grid-pp_gridpp_simple_14_1.png" src="../../_images/notebooks_grid-pp_gridpp_simple_14_1.png" />
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>